<template>
    <div class="modal fade" id="modalNewRoom" tabindex="-1" aria-labelledby="modalNewRoom" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h1 class="modal-title fs-5">Novo Quarto</h1>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close" id="btn-close-room"></button>
                </div>
                <div class="modal-body">
                    <div class="d-flex flex-column gap-3">
                        <div>
                            <label for="number" class="form-label">Número do Quarto</label>
                            <input type="text" class="form-control" placeholder="-" aria-label="number" v-model="form.number" disabled>
                        </div>
                        <div>
                            <label for="floor" class="form-label">Andar</label>
                            <select class="form-select" aria-label="floor" v-model="form.floor">
                                <option selected disabled value="undefined">Selecione o andar</option>
                                <option v-for="floor in 9" :key="floor" :value="floor">{{ floor }}º andar</option>
                            </select>
                        </div>
                        <div>
                            <label for="capacity" class="form-label">Capacidade</label>
                            <select class="form-select" aria-label="capacity" v-model="form.capacity">
                                <option selected disabled  value="undefined">Selecione a capacidade</option>
                                <option v-for="capacity in 5" :key="capacity" :value="capacity">{{ capacity }} pessoa(s)</option>
                            </select>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <div class="form-check">
                        <input class="form-check-input" type="checkbox" v-model="multipleAdd" id="multipleAdd">
                        <label class="form-check-label" for="multipleAdd">
                            <small>Adição múltipla</small>
                        </label>
                    </div>
                    <div class="d-flex gap-2">
                        <button type="button" class="btn btn-sm btn-secondary" data-bs-dismiss="modal">Cancelar</button>
                        <button type="button" class="btn btn-sm btn-primary" @click="addRoom">Adicionar</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import ServiceAPI from "@/services/ServiceAPI"

export default {
    name: 'ModalNewRoom',
    data: () => ({
        form: {
            number: null,
            floor: undefined,
            capacity: undefined
        },
        multipleAdd: false
    }),
    methods: {
        async addRoom() {
            await ServiceAPI.addRoom(this.form)
                .then(() => {
                    this.clearInputs()
                    this.$store.commit('setAlert', {
                        alert: true,
                        messageAlert: "Quarto adicionado com sucesso",
                        error: false                        
                    })
                    if (!this.multipleAdd) this.close()
                }).finally(() => {
                    this.$store.commit('refreshInfos')
                })
        },
        clearInputs() {
            this.form = {
                number: null,
                floor: undefined,
                capacity: undefined
            }
        },
        close() {
            document.getElementById("btn-close-room").click()
        }
    },
    watch: {
        'form.floor': function() {
            if (this.form.floor != undefined) {
                ServiceAPI.getRoomsByFloor(this.form.floor)
                    .then((response) => {
                        let lastRoom = 0
                        for (let i = 0; i < response.data.length; i++) {
                            let room = response.data[i]
                            if (room.number > lastRoom) {
                                lastRoom = room.number
                            }
                        }
                        lastRoom > 0 ? this.form.number = lastRoom + 1 : this.form.number = this.form.floor*100+1
                    })
            }
        }
    }
}
</script>

<style scoped>
.modal-footer {
    display: flex;
    justify-content: space-between;
}
</style>
